Bug 593898

Summary: after upgrade Fedora, X11 lose local keyboard layout.
Product: [Fedora] Fedora Reporter: Sergio Monteiro Basto <sergio>
Component: system-config-keyboardAssignee: Adel Gadllah <adel.gadllah>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: 13CC: adel.gadllah, jwbillgriffith, lkundrak, peter.hutterer, shur
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-06-27 12:29:55 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Sergio Monteiro Basto 2010-05-19 21:46:05 EDT
Description of problem:
system-setup-keyboard hangs with root user and do nothing with regular user.

Version-Release number of selected component (if applicable):
system-setup-keyboard-0.8.5-1.fc13.x86_64

How reproducible:
Use x86_64, and try set your keyboard but us.

  
Actual results:
strace system-setup-keyboard
ends with 
access("/etc/X11/xorg.conf.d", W_OK|X_OK) = -1 EACCES (Permission denied)
exit_group(1) 

as root:
strace system-setup-keyboard (hangs untiel press ^C)
inotify_add_watch(3, "/etc/sysconfig/keyboard", IN_MODIFY) = 1
read(3, ^X^C <unfinished ...>

cat /etc/sysconfig/keyboard


Expected results:
setup pt keyboard on x startup .

Additional info:
Comment 1 Sergio Monteiro Basto 2010-05-20 20:57:40 EDT
gdb system-setup-keyboard 
(...)Starting program: /usr/bin/system-setup-keyboard 
^C
Program received signal SIGINT, Interrupt.
(...) 
(gdb) bt
#0  0x00007ffff78371b0 in __read_nocancel () from /lib64/libc.so.6
#1  0x00000000004016be in read (argc=<value optimized out>, argv=<value optimized out>)
    at /usr/include/bits/unistd.h:45
#2  wait_for_updates (argc=<value optimized out>, argv=<value optimized out>) at system-setup-keyboard.c:177
#3  main (argc=<value optimized out>, argv=<value optimized out>) at system-setup-keyboard.c:216


cat /etc/sysconfig/keyboard
KEYBOARDTYPE="pc"
KEYTABLE="pt-latin1"
MODEL="pc105"
LAYOUT="pt"
Comment 2 Sergio Monteiro Basto 2010-05-20 21:09:47 EDT
for the record 

after run system-setup-keyboard with gdb , ctrl+c break the loop and type continue, gdb said "program has exit normally", and system-setup-keyboard
wrote /etc/X11/xorg.conf.d/00-system-setup-keyboard.conf 
which make my keyboard start in right language as supposed to .  

cat /etc/X11/xorg.conf.d/00-system-setup-keyboard.conf 
# This file is autogenerated by system-setup-keyboard. Any 
# modifications will be lost.

Section "InputClass"
        Identifier      "system-setup-keyboard"
        MatchIsKeyboard "on"
        Option          "XkbModel"      "pc105"
        Option          "XkbLayout"     "pt"
#       Option          "XkbVariant"    "(null)"
        Option          "XkbOptions"    "terminate:ctrl_alt_bksp,"
EndSection
Comment 3 Peter Hutterer 2010-05-23 20:00:30 EDT
system-setup-keyboard is a daemon that waits for a modification of the /etc/sysconfig/keyboard file. If you change it, s-s-k will update the xorg.conf.d snippet. Other than that, it does nothing - hence why it looks like it hangs.

it's not intended to be called by a user (or root, for that matter), it's started  by upstart when you enter runlevel 5. what problem are you trying to solve here?
Comment 4 Sergio Monteiro Basto 2010-05-24 08:48:06 EDT
(In reply to comment #3)
> system-setup-keyboard is a daemon that waits for a modification of the
> /etc/sysconfig/keyboard file. If you change it, s-s-k will update the
> xorg.conf.d snippet. Other than that, it does nothing - hence why it looks like
> it hangs.
> 
> it's not intended to be called by a user (or root, for that matter), it's
> started  by upstart when you enter runlevel 5. what problem are you trying to
> solve here?    

Hi,
After upgrade to f13 , keyboard was reset to US , to setup my "pt-latin1" keyboard, I somehow had to run something.
I think I confuse system-setup-keyboard and system-config-keyboard .
maybe just run system-config-keyboard and restart computer (not x), keyboard may work in pt.

I understand what I need is /etc/X11/xorg.conf.d/00-system-setup-keyboard.conf and /etc/sysconfig/keyboard set correctly.

In general was a upgrade problem ...
Comment 5 Sergio Monteiro Basto 2010-05-24 21:39:46 EDT
Hi,
Since evdev keyboard drive by default on fedora, after upgrade fedora (with a new version of X.org) setting any keyboard layout has been confuse. 
On upgrade to fedora 13, I got the reset of layout keyboard to us, again!, when X starts.
I though running system-config-keyboard, this command write the settings of /etc/X11/xorg.conf.d/00-system-setup-keyboard.conf , and once this done the layout keyboard is fixed.

Since "it's not intended to be called by a user", shouldn't be called system-, as system- are the set of tools to setup the system , my 2 cents. 

More important, How is supposed to setup my language keyboard layout ? 
My x86_64, after upgrade haven't the correct layout, What is the correct way to setup X keyboard ? I'm missing that. 

BTW: system-config-keyboard, which is a command to be called by a user, writes this on /etc/X11/xorg.conf:

# This configuration file was broken by system-config-keyboard

which is true , and don't do a backup which is even better.
Comment 6 Sergio Monteiro Basto 2010-06-04 08:55:06 EDT
Change to system-config-keyboard, 
https://bugzilla.redhat.com/show_bug.cgi?id=593898#c5 , has  what system-config-keyboard should do since evdev is the default drive.
Comment 7 Michael Shurtleff 2010-11-16 21:04:58 EST
I found that if you use system-setup-keyboard on the system console as root, it will change the file /etc/sysconfig/keyboard, and that seems to do the trick to change the default system keyboard (on your next boot). You can get a console window by control-alt-F2 for example, or by booting to level 2.

I had tried using the keyboard config on the system menu as a gnome user (not root), but when I tried to remove the US English for myself as user it would replace it and make it default at the next bootup. To me this is a bug on Fedora 14 or Gnome 2.32, since the user should have control over his own environment and not be subject to system override. But if you change the system default, that will carry over into Gnome user accounts, so as long as you have root privileges, it is not a major problem.
Comment 8 Bug Zapper 2011-06-02 09:48:52 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 9 Sergio Monteiro Basto 2011-06-02 11:23:28 EDT
upgrade to f14 and upgarde to f15 , no issue to report
Comment 10 Bug Zapper 2011-06-27 12:29:55 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 11 JW Griffith 2011-11-29 16:23:52 EST
Bsck in Fedora 14